/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;

import android.content.Context;
import android.database.Cursor;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;
import android.telephony.PhoneNumberUtils;
import android.util.Log;

import java.util.HashMap;

public class Contact {
    private static HashMap<String, String> sContactCache;//静态哈希表，用于缓存已查询的电话号码和对应的联系人姓名
    private static final String TAG = "Contact";// 日志标签，用于标识日志来源

    // 查询联系人的SQL语句模板，使用PHONE_NUMBERS_EQUAL函数比较电话号码
    // 查找匹配给定电话号码的联系人，并确保数据类型是Ph
    private static final String CALLER_ID_SELECTION = "PHONE_NUMBERS_EQUAL(" + Phone.NUMBER
    + ",?) AND " + Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "'"
    + " AND " + Data.RAW_CONTACT_ID + " IN "
            + "(SELECT raw_contact_id "
            + " FROM phone_lookup"
            + " WHERE min_match = '+')";

     // 根据电话号码获取联系人姓名的静态方法
    public static String getContact(Context context, String phoneNumber) {
        if(sContactCache == null) {
            sContactCache = new HashMap<String, String>();
        }

        // 检查缓存中是否已有该电话号码的联系人信息
        if(sContactCache.containsKey(phoneNumber)) {
            return sContactCache.get(phoneNumber);
        }

        // 替换SQL模板中的"+"为实际的最小匹配值，以适应不同格式的电话号码
        String selection = CALLER_ID_SELECTION.replace("+",
                PhoneNumberUtils.toCallerIDMinMatch(phoneNumber));
         // 执行联系人数据库查询，获取匹配的联系人姓名
        Cursor cursor = context.getContentResolver().query(
                Data.CONTENT_URI,
                new String [] { Phone.DISPLAY_NAME },
                selection,
                new String[] { phoneNumber },
                null);

			// 处理查询结果
        if (cursor != null && cursor.moveToFirst()) {
            try {
                String name = cursor.getString(0);//获取联系人姓名
                sContactCache.put(phoneNumber, name);// 将结果存入缓存
                return name;
            } catch (IndexOutOfBoundsException e) {
              // 处理可能的索引越界异常
                Log.e(TAG, " Cursor get string error " + e.toString());
                return null;
            } finally {
              // 确保游标被关闭，避免资源泄漏
                cursor.close();
            }
        } else {
          // 没有找到匹配的联系人
            Log.d(TAG, "No contact matched with number:" + phoneNumber);
            return null;
        }
    }
}
